/*    
    PowerDVD Plugin for ATI Remote Wonder
    Copyright 2002-2006 Jonathan Zarate
	http://www.polarcloud.com

    This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation; either version 2 of the License, or (at your
	option) any later version.

    This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
	or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
	for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "stdafx.h"
#include "config.h"
#include "global.h"
#include "actioncodes.h"
#include "mixer.h"


BOOL APIENTRY DllMain(HINSTANCE hDLLInst, DWORD  dwReason, LPVOID) 
{
	if (dwReason == DLL_PROCESS_ATTACH) {
		hInst = hDLLInst;
		LoadConfig();
	}
    return TRUE;
}


// ugly... but SetForegroundWindow() will not work across processes without these
void ForceForeground(HWND hWnd)
{
	DWORD a;
	DWORD It;

	if (IsIconic(hWnd)) ShowWindow(hWnd, SW_RESTORE);
	if (GetForegroundWindow() == hWnd) return;
	a = GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	It = GetWindowThreadProcessId(hWnd, NULL);
	AttachThreadInput(a, It, TRUE);
	BringWindowToTop(hWnd);
	SetForegroundWindow(hWnd);
	AttachThreadInput(a, It, FALSE);
	SetForegroundWindow(hWnd);	// ?
}

void KeyDown(DWORD Code)
{
	BYTE mvk;
	BYTE mvkc;

	if (Code & ACTF_KEY_CTRL) {
		mvkc = MapVirtualKey(VK_CONTROL, 0);
		keybd_event(VK_CONTROL, mvkc, 0, 0);
	}
//	if (Code & ACTF_KEY_ALT) keybd_event(VK_MENU, 0, 0, 0);
//	if (Code & ACTF_KEY_SHIFT) keybd_event(VK_LSHIFT, 0, 0, 0);
	mvk = MapVirtualKey((BYTE)Code, 0);
	keybd_event((BYTE)Code, mvk, 0, 0);
	keybd_event((BYTE)Code, mvk, KEYEVENTF_KEYUP, 0);
//	if (Code & ACTF_KEY_SHIFT) keybd_event(VK_LSHIFT, 0, KEYEVENTF_KEYUP, 0);
//	if (Code & ACTF_KEY_ALT) keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0);
	if (Code & ACTF_KEY_CTRL) {
		keybd_event(VK_CONTROL, mvkc, KEYEVENTF_KEYUP, 0);
	}
}

DWORD WhatKeysDoYouWant(void)
{
	return (CUSTOM_RAW|MOUSE_GROUP|CHANNEL_GROUP|VOLUME_GROUP|NUMBER_GROUP|
		CURSOR_GROUP|PLAY_GROUP|MENU|SETUP|ENTER|RECORD|STOPWATCH|RESIZE|WEB_LAUNCH);
}

char *EnumerateProgrammableFunction(WORD wIndex)
{	
	return NULL;
}

void Configure(HWND hWnd)
{
	ConfigDialog(hWnd);
}


BOOL HandleKey (BOOL bCustom, WORD wKeyEvent, WORD wState)
{
	HWND hTarget;
	DWORD ActionCode;
	int i;

	// things that should not be here
	if (bCustom) {
		return FALSE;
	}
	if (wKeyEvent >= MAX_WONDER_KEYS) {
		return FALSE;
	}

	if ((hTarget = FindWindow(viewerClass, viewerTitle)) == NULL) {
		return FALSE;
	}

	ActionCode = ActionMap[wKeyEvent] & ~ACTF_ALTCODE;
	if (ActionCode == ACT_NONE) return FALSE;
	if (ActionCode == ACT_IGNORE) return TRUE;

	if (((wState == RMCTRL_KEY_ON) && ((ActionCode & ACTF_NO_DOWN) == 0)) ||
		((wState == RMCTRL_KEY_REPEAT) && (ActionCode & ACTF_ON_REPEAT)) ||
		((wState == RMCTRL_KEY_OFF) && (ActionCode & ACTF_ON_UP))) {
		switch (ActionCode & ACTF_F_MASK) {
		case ACTF_F_SPECIAL:
			switch (ActionCode) {
			case ACT_MIXVOLUP:
			case ACT_MIXVOLDN:
			case ACT_MIXVOLMUTE:
				MixerEvent(ActionCode, wState);
				break;
			case ACT_PLUGINSETUP:
				// note: this will block the remote
				ConfigDialog(NULL);
				break;
			case ACT_RESUME:
				ForceForeground(hTarget);
				KeyDown(VK_ESCAPE);
				KeyDown('L');
				KeyDown(VK_UP);
				KeyDown(VK_RETURN);
				KeyDown(VK_ESCAPE);
				break;
			default:
				if ((ActionCode >= ACT_MENUTITLE) && (ActionCode <= ACT_MENUCHAPTER)) {
					ForceForeground(hTarget);
					KeyDown(VK_ESCAPE);
					KeyDown('L');
					for (i = ActionCode - ACT_MENUTITLE; i >= 0; --i) {
						KeyDown(VK_DOWN);
					}
					KeyDown(VK_RETURN);
					KeyDown(VK_ESCAPE);
				}
			}
			break;
		case ACTF_F_KEYDOWN:
			ForceForeground(hTarget);
			KeyDown(ActionCode);
			break;
		}
	}

	return TRUE;
}

int AreYouInFocus (void)
{
	HWND hForeground;
	char c[32];
	char t[32];
	char x[256];

	if ((hForeground = GetForegroundWindow()) == NULL) return 0;

	GetClassName(hForeground, c, sizeof(c));
	GetWindowText(hForeground, t, sizeof(t));

	if (autoFix) {
		sprintf(x, "Use class \"%s\" and title \"%s\"?", c, t);
		if (MessageBox(NULL, x, "PowerDVD Plugin", MB_YESNO) == IDYES) {
			strcpy(viewerClass, c);
			strcpy(viewerTitle, t);
			SaveWindowConfig();
			autoFix = 0;
		}
	}

	return (strcmp(c, viewerClass) == 0) && (strcmp(t, viewerTitle) == 0);
}

